﻿using System;
using System.Linq;
using System.Web.Mvc;
using System.Collections;
using ScheduleCRUD.Models;
using System.Collections.Generic;
using Syncfusion.JavaScript.Models;

namespace ScheduleCRUD.Controllers
{
    public class HomeController : Controller
    {
        DataClasses1DataContext db = new DataClasses1DataContext();
        public ActionResult Index()
        {
            List<String> Group = new List<String>() { "Operators" };

            List<ResourceFields> Operators = new List<ResourceFields>()
            {
                new ResourceFields { Id = "1", Text = "Nancy", Color = "#f8a398", GroupId = "1" },
                new ResourceFields { Id = "3", Text = "Steven", Color = "#56ca95", GroupId = "1" },
                new ResourceFields { Id = "5", Text = "Michael", Color = "#51a0ed", GroupId = "1" },
                //new ResourceFields { Id = "7", Text = "Laura", Color = "#ffaa00", GroupId = "1" },
                //new ResourceFields { Id = "9", Text = "Robert", Color = "#c3c3c3", GroupId = "1" }
            };

            List<appointment> appointment = new List<appointment>()
            {
                new appointment { Id = 1, Subject = "Meeting", StartTime = new DateTime(2017, 1, 2, 4, 30, 0), EndTime = new DateTime(2017, 1, 2, 5, 30, 0), Description="", AllDay = false, Recurrence = false },
                new appointment { Id = 2, Subject = "Conference", StartTime = new DateTime(2017, 1, 3, 6, 30, 0), EndTime = new DateTime(2017, 1, 3, 7, 30, 0), Description="", AllDay = false, Recurrence = false },
                new appointment { Id = 3, Subject = "Tourism", StartTime = new DateTime(2017, 1, 4, 5, 0, 0), EndTime = new DateTime(2017, 1, 4, 6, 30, 0), Description="", AllDay = false, Recurrence = false },
                new appointment { Id = 4, Subject = "Movies", StartTime = new DateTime(2017, 1, 5, 10, 0, 0), EndTime = new DateTime(2017, 1, 5, 11, 30, 0), Description="", AllDay = false, Recurrence = false },
                new appointment { Id = 5, Subject = "Holidays Plan", StartTime = new DateTime(2017, 1, 6, 8, 0, 0), EndTime = new DateTime(2017, 1, 6, 9, 30, 0), Description="", AllDay = false, Recurrence = true, RecurrenceRule = "FREQ=DAILY;INTERVAL=2;COUNT=10" }
            };

            ViewBag.Resources = Group;
            ViewBag.Operators = Operators;
            ViewBag.dataSource = appointment;
            return View();
        }

        public JsonResult GetData()
        {
            IEnumerable data = db.ScheduleDatas.Take(100);
            return Json(data, JsonRequestBehavior.AllowGet);
        }

        public JsonResult Batch(EditParams param)
        {
            if (param.action == "insert" || (param.action == "batch" && param.added != null)) // this block of code will execute while inserting the appointments
            {
                ScheduleData appoint = new ScheduleData();
                object result;
                if (param.action == "insert")
                {
                    var value = param.value;
                    foreach (var fieldName in value.GetType().GetProperties())
                    {
                        var newName = fieldName.ToString().Split(null);
                        if (newName[1] == "Id") result = (db.ScheduleDatas.ToList().Count > 0 ? db.ScheduleDatas.ToList().Max(p => p.Id) : 1) + 1;
                        else if (newName[1] == "StartTime" || newName[1] == "EndTime") result = Convert.ToDateTime(fieldName.GetValue(value));
                        else result = fieldName.GetValue(value);
                        fieldName.SetValue(appoint, result);
                    }
                    db.ScheduleDatas.InsertOnSubmit(appoint);
                }
                else
                {
                    foreach (var item in param.added.Select((x, i) => new { Value = x, Index = i }))
                    {
                        var value = item.Value;
                        foreach (var fieldName in value.GetType().GetProperties())
                        {
                            var newName = fieldName.ToString().Split(null);
                            if (newName[1] == "Id") result = (db.ScheduleDatas.ToList().Count > 0 ? db.ScheduleDatas.ToList().Max(p => p.Id) : 1) + 1 + item.Index;
                            else if (newName[1] == "StartTime" || newName[1] == "EndTime") result = Convert.ToDateTime(fieldName.GetValue(value));
                            else result = fieldName.GetValue(value);
                            fieldName.SetValue(appoint, result);
                        }
                        db.ScheduleDatas.InsertOnSubmit(appoint);
                    }
                }
                db.SubmitChanges();
            }
            if ((param.action == "remove") || (param.action == "batch" && param.deleted != null)) // this block of code will execute while removing the appointment
            {
                if (param.action == "remove")
                {
                    ScheduleData app = db.ScheduleDatas.Where(c => c.Id == Convert.ToInt32(param.key)).FirstOrDefault();
                    if (app != null) db.ScheduleDatas.DeleteOnSubmit(app);
                }
                else
                {
                    foreach (var a in param.deleted)
                    {
                        var app = db.ScheduleDatas.ToList().Where(c => c.Id == Convert.ToInt32(a.Id)).FirstOrDefault();
                        if (app != null) db.ScheduleDatas.DeleteOnSubmit(app);
                    }
                }
                db.SubmitChanges();
            }
            if (param.action == "update" || (param.action == "batch" && param.changed != null)) // this block of code will execute while updating the appointment
            {
                var value = param.action == "update" ? param.value : param.changed[0];
                var filterData = db.ScheduleDatas.Where(c => c.Id == Convert.ToInt32(value.Id));
                if (filterData.Count() > 0)
                {
                    ScheduleData appoint = db.ScheduleDatas.Single(A => A.Id == Convert.ToInt32(value.Id));
                    appoint.StartTime = Convert.ToDateTime(value.StartTime);
                    appoint.EndTime = Convert.ToDateTime(value.EndTime);
                    appoint.StartTimeZone = value.StartTimeZone;
                    appoint.EndTimeZone = value.EndTimeZone;
                    appoint.Subject = value.Subject;
                    appoint.Recurrence = value.Recurrence;
                    appoint.AllDay = value.AllDay;
                    appoint.RecurrenceRule = value.RecurrenceRule;
                    appoint.Categorize = value.Categorize;
                    appoint.OperatorId = value.OperatorId;
                }
                db.SubmitChanges();
            }
            IEnumerable data = new DataClasses1DataContext().ScheduleDatas.Take(500);
            return Json(data, JsonRequestBehavior.AllowGet);
        }
    }

    public class appointment
    {
        public int Id { get; set; }
        public string Subject { get; set; }
        public DateTime StartTime { get; set; }
        public DateTime EndTime { get; set; }
        public string Description { get; set; }
        public bool AllDay { get; set; }
        public bool Recurrence { get; set; }
        public string RecurrenceRule { get; set; }
    }
}